/*
 * Copyright (c) 2005-, Claybird
 * All rights reserved.

 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:

 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name of the Claybird nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.

 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
 * AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF
 * THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

#include "stdafx.h"
#include "resource.h"
#include "main.h"
#include "ConfigCode/configwnd.h"
#include "compress.h"
#include "extract.h"
#include "TestArchive.h"
#include "ArchiverCode/arc_interface.h"
#include "FileListWindow/FileListFrame.h"
#include "ArchiverManager.h"
#include "Dialogs/SelectDlg.h"
#include "Dialogs/ProgressDlg.h"
#include "Utilities/OSUtil.h"
#include "Utilities/StringUtil.h"
#include "Update.h"
#include "CmdLineInfo.h"

CAppModule _Module;


//---------------------------------------------

//Gg[|Cg
int WINAPI _tWinMain(HINSTANCE hInstance, HINSTANCE, LPTSTR lpCmdLine, int nCmdShow)
{
#if defined(_DEBUG)
	// [Nop
	_CrtSetDbgFlag(
		_CRTDBG_ALLOC_MEM_DF
		| _CRTDBG_LEAK_CHECK_DF
		);
#endif
	_tsetlocale(LC_ALL,_T(""));	//P[ϐ擾

	HRESULT hRes = ::CoInitialize(NULL);
	ATLASSERT(SUCCEEDED(hRes));
	OleInitialize(NULL);
	// Microsoft Layer for Unicode (MSLU) gpꂽ
	// ATLEChE thunking 
	::DefWindowProc(NULL, 0, 0, 0L);

	// ̃Rg[T|[g邽߂̃tOǉ
	AtlInitCommonControls(ICC_WIN95_CLASSES|ICC_COOL_CLASSES | ICC_BAR_CLASSES);
	_Module.Init(NULL,hInstance);
	CMessageLoop theLoop;
	_Module.AddMessageLoop(&theLoop);

	//*********************************
	// R}hCp[^̉
	//*********************************
	/*
	IvVw`:

	/b2e		B2E32.dllgp
	/c:???		???`Ŏw肳ꂽt@Ck(???=lzh,zip,etc...)
	/method:???	???\bhgĈk(B2Ê)
	/b2esfx		ȉ𓀌`ňk(B2Ê)
	/e			t@C
	/o:[dir]	o͐fBNgw
	/l			A[JCut@C̃Xg\(P)
	/f:[file]	ko̓t@C̎w(pXw͖)
	/xacrett	XacRett.DLLIɎgp(/{)
	/!			/xacrettƓ
	/m			t@C𓀂̓Xg\(ݒɂύX)
	/s			t@CEtH_k
	/t			A[JCut@C̊SeXg
	/@[file]	X|Xt@Cw
	/$[file]	X|Xt@Cw:X|Xt@C͓ǂݎ芮폜

	*/

	bool bCheckUpdate=true;	//LFCaldixNȂtrue

	CMDLINEINFO cli;	//CommandLineInfo

	CConfigManager ConfigManager;
	PROCESS_MODE ProcessMode=ParseCommandLine(ConfigManager,cli);

	//Dxݒ
	{
		CConfigGeneral ConfGeneral;
		ConfGeneral.load(ConfigManager);
		LFPROCESS_PRIORITY priority=(LFPROCESS_PRIORITY)ConfGeneral.ProcessPriority;
		//R}hCIvVŏ㏑?
		if(cli.PriorityOverride!=LFPRIOTITY_DEFAULT){
			priority=cli.PriorityOverride;
		}
		switch(priority){
		case LFPRIOTITY_LOW:
			UtilSetPriorityClass(IDLE_PRIORITY_CLASS);break;
		case LFPRIOTITY_LOWER:
			UtilSetPriorityClass(BELOW_NORMAL_PRIORITY_CLASS);break;
		case LFPRIOTITY_NORMAL:
			UtilSetPriorityClass(NORMAL_PRIORITY_CLASS);break;
		case LFPRIOTITY_HIGHER:
			UtilSetPriorityClass(ABOVE_NORMAL_PRIORITY_CLASS);break;
		case LFPRIOTITY_HIGH:
			UtilSetPriorityClass(HIGH_PRIORITY_CLASS);break;
		case LFPRIOTITY_DEFAULT:
		default:
			//nothing to do
			break;
		}
	}

	CString strErr;
	if(PROCESS_LIST!=ProcessMode && cli.FileList.empty()){
		//t@CꗗEBhEoꍇȊÓAt@Cw肪Ƃ͐ݒ_CAOo
		ProcessMode=PROCESS_CONFIGURE;
	}
	CArchiverDLLManager::GetInstance().SetConfigManager(ConfigManager);

	//DLLCXg[擾%PATH%ɒǉ
	CConfigUpdate ConfUpdate;
	ConfUpdate.load(ConfigManager);
	{
		//R}hEp[^WJ
		//---Vϐ
		CString strPath=ConfUpdate.strDLLPath;
		if(!strPath.IsEmpty()){
			//---s擾
			//p[^WJɕKvȏ
			std::map<stdString,CString> envInfo;
			UtilMakeExpandInformation(envInfo);
			//ϐWJ
			UtilExpandTemplateString(strPath, strPath, envInfo);

			//΃pXɕϊ
			if(PathIsRelative(strPath)){
				CPath tmp=UtilGetModuleDirectoryPath();
				tmp.AddBackslash();
				tmp+=strPath;
				strPath=(LPCTSTR)tmp;
			}
			UtilGetCompletePathName(strPath,strPath);
			strPath+=_T(";");
			//---ϐ擾
			int len=GetEnvironmentVariable(_T("PATH"),NULL,0);
			CString strEnv;
			GetEnvironmentVariable(_T("PATH"),strEnv.GetBuffer(len+1),len);
			strEnv.ReleaseBuffer();

			strPath+=strEnv;
			SetEnvironmentVariable(_T("PATH"),strPath);
		}
	}

	switch(ProcessMode){
	case PROCESS_COMPRESS://k
		DoCompress(ConfigManager,cli);
		break;
	case PROCESS_EXTRACT://
		DoExtract(ConfigManager,cli);
		break;
	case PROCESS_AUTOMATIC://C
		if(PathIsDirectory(*cli.FileList.begin())){
			DoCompress(ConfigManager,cli);
		}else{
			CConfigExtract ConfExtract;
			ConfExtract.load(ConfigManager);
			if(CArchiverDLLManager::GetInstance().GetArchiver(*cli.FileList.begin(),ConfExtract.DenyExt,cli.idForceDLL)){	//𓀉\Ȍ`ǂ
				DoExtract(ConfigManager,cli);
			}else{
				DoCompress(ConfigManager,cli);
			}
		}
		break;
	case PROCESS_LIST://Xg\
		DoList(ConfigManager,cli);
		break;
	case PROCESS_TEST://A[JCut@C̃eXg
		DoTest(ConfigManager,cli);
		break;
	case PROCESS_CONFIGURE://ݒʕ\
		{
			//ŊmFŝŏI̊mF͕sv
			bCheckUpdate=false;
			//DLLXVmF
			if(CheckUpdateArchiverDLLRequired(ConfUpdate)){
				DoUpdateArchiverDLL(ConfigManager);
			}
			//_CAO\
			CConfigDialog confdlg(ConfigManager);
			if(IDOK==confdlg.DoModal()){
				if(!ConfigManager.SaveConfig(strErr)){
					ErrorMessage(strErr);
				}
			}
		}
		break;
	case PROCESS_INVALID:
		TRACE(_T("Process Mode Undefined\n"));
		break;
	default:
		ASSERT(!"Unexpected Process Mode");
	}
	//Abvf[g`FbN
	if(bCheckUpdate){
		//DLLXVmF
		if(CheckUpdateArchiverDLLRequired(ConfUpdate)){
			DoUpdateArchiverDLL(ConfigManager);
		}
	}

	TRACE(_T("Terminating...\n"));
	CArchiverDLLManager::GetInstance().Final();
//	Sleep(1);	//ΏǗÖ@ for 0xC0000005: Access Violation
	_Module.RemoveMessageLoop();
	_Module.Term();
	OleUninitialize();
	::CoUninitialize();
	TRACE(_T("Exit main()\n"));
	return 0;
}

bool DoCompress(CConfigManager &ConfigManager,CMDLINEINFO &cli)
{
	//kIvVw
	CString strFormat=cli.strFormat;
	CString strMethod=cli.strMethod;
	CString strLevel=cli.strLevel;

	if(cli.idForceDLL==DLL_ID_B2E){
		cli.CompressType=PARAMETER_B2E;
	}

	CConfigCompress ConfCompress;
	CConfigGeneral ConfGeneral;
	ConfCompress.load(ConfigManager);
	ConfGeneral.load(ConfigManager);

	while(PARAMETER_UNDEFINED==cli.CompressType || PARAMETER_B2E==cli.CompressType){	//---gpDLL
		if(PARAMETER_UNDEFINED==cli.CompressType){	//`w肳ĂȂꍇ
			if(ConfCompress.UseDefaultParameter){	//ftHgp[^gȂf[^擾
				cli.CompressType=ConfCompress.DefaultType;
				cli.Options=ConfCompress.DefaultOptions;

				if(cli.CompressType==PARAMETER_B2E){	//B2Egpꍇ
					cli.idForceDLL=DLL_ID_B2E;	//B2E32.dll̎gp𖾎
					//p[^w
					if(cli.Options)cli.Options=COMPRESS_SFX;	//ȉ
					cli.strFormat=ConfCompress.DefaultB2EFormat;	//`
					cli.strMethod=ConfCompress.DefaultB2EMethod;	//\bh
				}
			}else{	//͂𑣂
				CSelectDialog SelDlg;
				SelDlg.SetDeleteAfterCompress(BOOL2bool(ConfCompress.DeleteAfterCompress));
				cli.CompressType=(PARAMETER_TYPE)SelDlg.DoModal();
				if(PARAMETER_UNDEFINED==cli.CompressType){	//LZ̏ꍇ
					return false;
				}else if(cli.CompressType!=PARAMETER_B2E){
					cli.idForceDLL=DLL_ID_UNKNOWN;

					cli.Options=SelDlg.GetOptions();
					cli.bSingleCompression=SelDlg.IsSingleCompression();
					cli.DeleteAfterProcess=SelDlg.GetDeleteAfterCompress() ? 1 : 0;
					break;
				}
			}
		}
		if(cli.CompressType==PARAMETER_B2E){	//B2Egpꍇ
			//---B2E32.dll̃`FbN
			CArchiverB2E &B2EHandler=CArchiverDLLManager::GetInstance().GetB2EHandler();
			if(!B2EHandler.IsOK()){
				cli.CompressType=PARAMETER_UNDEFINED;
				CString msg;
				msg.Format(IDS_ERROR_DLL_LOAD,B2EHandler.GetName());
				ErrorMessage(msg);
				continue;
//				return false;
			}

			//---`I
			if(cli.strFormat.IsEmpty()){
				CB2ESelectDialog SelDlg;
				INT_PTR Ret=SelDlg.DoModal();
				if(IDCANCEL==Ret){	//LZ̏ꍇ
					return false;
				}else if(IDC_COMPRESS_USENORMAL==Ret){	//ʏDLLg
					cli.CompressType=PARAMETER_UNDEFINED;
				}else{
					cli.idForceDLL=DLL_ID_B2E;

					cli.Options=SelDlg.IsSFX() ? COMPRESS_SFX : 0;
					cli.bSingleCompression=SelDlg.IsSingleCompression();
					strFormat=SelDlg.GetFormat();
					strMethod=SelDlg.GetMethod();
					break;
				}
			}else{
				strFormat=cli.strFormat;
				strMethod=cli.strMethod;
				break;
			}
		}
	}

	//--------------------
	// k

	if(cli.bSingleCompression){	//t@Ck
		//bZ[W[v񂷂߂̃^C}[
		int timer=SetTimer(NULL,NULL,1000,UtilMessageLoopTimerProc);
		//vOXo[
		CProgressDialog dlg;
		int nFiles=cli.FileList.size();
		if(nFiles>=2){	//t@C鎞Ɍ
			dlg.Create(NULL);
			dlg.SetTotalFileCount(nFiles);
			dlg.ShowWindow(SW_SHOW);
		}
		bool bRet=true;
		for(std::list<CString>::iterator ite=cli.FileList.begin();ite!=cli.FileList.end();ite++){
			//vOXo[i߂
			if(dlg.IsWindow())dlg.SetNextState(*ite);
			while(UtilDoMessageLoop())continue;

			//k
			std::list<CString> TempList;
			TempList.push_back(*ite);

			bRet=bRet && Compress(TempList,cli.CompressType,ConfigManager,strFormat,strMethod,strLevel,cli);
		}
		//vOXo[
		if(dlg.IsWindow())dlg.DestroyWindow();

		//^C}[
		KillTimer(NULL,timer);
		return bRet;
	}else{	//ʏ툳k
		return Compress(cli.FileList,cli.CompressType,ConfigManager,strFormat,strMethod,strLevel,cli);
	}
}

bool DoExtract(CConfigManager &ConfigManager,CMDLINEINFO &cli)
{
	CConfigExtract ConfExtract;
	ConfExtract.load(ConfigManager);
	MakeListFilesOnly(cli.FileList,cli.idForceDLL,ConfExtract.DenyExt,true);
	if(cli.FileList.empty()){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILE_NOT_SPECIFIED)));
		return false;
	}
	return Extract(cli.FileList,ConfigManager,cli.idForceDLL,cli.OutputDir,&cli);
}

bool DoList(CConfigManager &ConfigManager,CMDLINEINFO &cli)
{
	CConfigExtract ConfExtract;
	ConfExtract.load(ConfigManager);
	bool bSpecified=!cli.FileList.empty();
	MakeListFilesOnly(cli.FileList,cli.idForceDLL,ConfExtract.DenyExt,true);
	//t@CXgɉcȂG[bZ[W\
	if(bSpecified && cli.FileList.empty()){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILE_NOT_SPECIFIED)));
	//	return false;
	}

//==========
// {Jn
//==========
	CFileListFrame ListWindow(ConfigManager);
	ListWindow.CreateEx();
	ListWindow.ShowWindow(SW_SHOW);
	ListWindow.UpdateWindow();
	//ListWindow.AddArchiveFile(*cli.FileList.begin());
	if(!cli.FileList.empty()){
		bool bAllFailed=true;
		std::list<CString>::iterator ite=cli.FileList.begin();
		const std::list<CString>::iterator End=cli.FileList.end();
		for(;ite!=cli.FileList.end();++ite){
			HRESULT hr=ListWindow.OpenArchiveFile(*ite,cli.idForceDLL);
			if(SUCCEEDED(hr)){
				if(hr!=S_FALSE)bAllFailed=false;
			}else if(hr==E_ABORT){
				break;
			}
		}
		if(bAllFailed)ListWindow.DestroyWindow();
	}

	CMessageLoop* pLoop = _Module.GetMessageLoop();
	pLoop->Run();
	TRACE(_T("Loop End\n"));
	return true;
}

//A[JCũeXg
bool DoTest(CConfigManager &ConfigManager,CMDLINEINFO &cli)
{
	CConfigExtract ConfExtract;
	ConfExtract.load(ConfigManager);
	//SẴt@CΏۂɂ
	MakeListFilesOnly(cli.FileList,cli.idForceDLL,ConfExtract.DenyExt,false);
	//t@CXgɉcȂG[bZ[W\
	if(cli.FileList.empty()){
		ErrorMessage(CString(MAKEINTRESOURCE(IDS_ERROR_FILE_NOT_SPECIFIED)));
		return false;
	}

	//eXg
	return TestArchive(cli.FileList,ConfigManager);
}

//XgtH_폜ATutH_̃t@Cǉ
void MakeListFilesOnly(std::list<CString> &FileList,DLL_ID idForceDLL,LPCTSTR lpDenyExt,bool bArchivesOnly)
{
	std::list<CString>::iterator ite;
	for(ite=FileList.begin();ite!=FileList.end();){
		if(PathIsDirectory(*ite)){
			//---𓀑ΏۂtH_ȂċA𓀂
			std::list<CString> subFileList;
			UtilRecursiveEnumFile(*ite,subFileList);

			for(std::list<CString>::iterator ite2=subFileList.begin();ite2!=subFileList.end();ite2++){
				if(!bArchivesOnly||CArchiverDLLManager::GetInstance().GetArchiver(*ite2,lpDenyExt,idForceDLL)){
					//ΉĂ`̂ݒǉKv鎞́A𓀉\Ȍ`ǂ肷
					FileList.push_back(*ite2);
				}
			}
			//͍폜
			ite=FileList.erase(ite);
		}
		else{
			ite++;
		}
	}
}
